#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os,sys,random

try: 
    bin_file = sys.argv[1]
except:
    print("\nUsage: %s /path/to/amiibo.bin\n" % sys.argv[0])
    raise SystemExit(0)
    
def changeserial():

    uid0 = random.randint(0,255)
    uid1 = random.randint(0,255)
    uid2 = random.randint(0,255)
    bcc0 = uid0 ^ uid1 ^ uid2 ^ 0x88
    uid3 = random.randint(0,255)
    uid4 = random.randint(0,255)
    uid5 = random.randint(0,255)
    uid6 = random.randint(0,255)
    bcc1 = uid3 ^ uid4 ^ uid5 ^uid6

    print("Using new serial: %02X%02X%02X%02X%02X%02X%02X%02X%02X" % (uid0, uid1, uid2, bcc0, uid3, uid4, uid5, uid6, bcc1))
    print("\nDecrypting %s\n" % bin_file)

    #decrypting to decrypt.bin
    print("amiitool.exe -d -k key_retail.bin -i '" + bin_file + "' -o decrypt.bin\n")
    os.system("amiitool.exe -d -k key_retail.bin -i '" + bin_file + "' -o decrypt.bin")

    try:
        with open('decrypt.bin', 'r+b') as fh:
            print("File decrypted\n")
            print("Injecting new serial\n")
            fh.seek(0, 0)
            fh.write(bytes([bcc1]))
            fh.seek(0x1D4, 0)
            fh.write(bytes([bcc0, uid0, uid1, uid2, uid3, uid4, uid5, uid6]))
            fh.close()
    except:
        print('\nAborting!\n')
        raise SystemExit(0)

    print("Encrypting file\n")
    print("amiitool.exe -e -k key_retail.bin -i decrypt.bin -o '" + bin_file[:-4] + "_%02X%02X%02X%02X%02X%02X%02X%02X%02X.bin'\n" % (uid0, uid1, uid2, bcc0, uid3, uid4, uid5, uid6, bcc1))
    os.system("amiitool.exe -e -k key_retail.bin -i decrypt.bin -o '" + bin_file[:-4] + "_%02X%02X%02X%02X%02X%02X%02X%02X%02X.bin'" % (uid0, uid1, uid2, bcc0, uid3, uid4, uid5, uid6, bcc1))

    print("Cleaning up...")
    #os.system("del decrypt.bin")

    print("Operation Complete\n\n")    
        
while True:
    quantity = input("\nQuantity [1]: ")
    if quantity == "":
        quantity = 1
    elif quantity.isdigit() is False:
        print("\nPositive numbers only\n")
        continue
    for i in range(int(quantity)):
        changeserial()
    break
SystemExit(0)